/*
	
	PasswordControl.cp
	
	Copyright 1998, Neil Miller. All Rights Reserved.

	This source is free; you can redistribute it and/or modify it under 
	the terms of the a modified GNU Library General Public License OR 
	Mozilla Public License.
	See "http://www.pobox.com/~ngm/be/index.html" for full details.

*/

#include "PasswordControl.h"
#include "PasswordView.h"

PasswordControl	::PasswordControl(BRect frame,
									const char *name,
									const char *label, 
									const char *initial_text, 
									BMessage *message,
									uint32 rmask,
									uint32 flags) : 
										BTextControl( frame,
										name, label, initial_text, 
										message, rmask, flags)
{
}

PasswordControl	::~PasswordControl()
{
}

PasswordControl	::PasswordControl(BMessage *data) : BTextControl( data )
{
}

void PasswordControl::AttachedToWindow()
{
	BMessage	mess;
	BTextView	*orig;
	BTextView	*test;

	BTextControl::AttachedToWindow();

	orig = TextView();
	if ( orig->Archive( &mess ) == B_OK ) {
		if ( RemoveChild( orig ) ) {
			password = new PasswordView( orig->Frame(), orig->Name(), orig->TextRect(),
									NULL, NULL, orig->ResizingMode(), 
									orig->Flags() | B_NAVIGABLE);
//			delete orig; // bad things happen if we do this.
			orig->Hide();
			orig->SetFlags(orig->Flags() & ~B_NAVIGABLE);
			AddChild( password );
		}
	}
}

const char *PasswordControl::Text() const
{
	return password->Text();
}

const char *PasswordControl::Password() const
{
	return password->Password();
}

// end